﻿Imports System.Net.Http
Imports Newtonsoft.Json

Public Class Form1

    Dim Uri As String

    Private Async Sub GetAllProdutos()
        Uri = txtURI.Text
        Using client = New HttpClient()
            Using response = Await client.GetAsync(Uri)
                If response.IsSuccessStatusCode Then
                    Dim ProdutoJsonString = Await response.Content.ReadAsStringAsync()
                    dgvDados.DataSource = JsonConvert.DeserializeObject(Of Produto())(ProdutoJsonString).ToList()
                Else
                    MessageBox.Show("Não foi possível obter o produto : " + response.StatusCode)
                End If
            End Using
        End Using
    End Sub

    Private Async Sub GetProdutoPorId(codProduto As Integer)
        Using client = New HttpClient()
            Dim bsDados As New BindingSource()
            Uri = txtURI.Text + "/" + codProduto.ToString()
            Dim response As HttpResponseMessage = Await client.GetAsync(Uri)
            If response.IsSuccessStatusCode Then
                Dim ProdutoJsonString = Await response.Content.ReadAsStringAsync()
                bsDados.DataSource = JsonConvert.DeserializeObject(Of Produto)(ProdutoJsonString)
                dgvDados.DataSource = bsDados
            Else
                MessageBox.Show("Falha ao obter o produto : " + response.StatusCode)
            End If
        End Using
    End Sub

    Private Sub btnSair_Click(sender As Object, e As EventArgs) Handles btnSair.Click
        Close()
    End Sub

    Private Sub btnProdutos_Click(sender As Object, e As EventArgs) Handles btnProdutos.Click
        GetAllProdutos()
    End Sub

    Private Sub btnProdutoPorID_Click(sender As Object, e As EventArgs) Handles btnProdutoPorID.Click
        Dim codigoProduto As String
        ' Exibe o inputbox na posição
        codigoProduto = InputBox("Informe o ID do produto", "Produto", 1, 200, 200)
        ' Se cancelar sai
        If codigoProduto <> "" Then
            GetProdutoPorId(Convert.ToInt32(codigoProduto))
        End If
    End Sub
End Class
